import 'package:flutter/services.dart';

class FlutterInAppUpdate {
  static const MethodChannel _channel =
      const MethodChannel('flutter_in_app_update');

  static Future<UpdateInfo> checkForUpdate({int stalenessDays = 14}) async {
    final result = await _channel
        .invokeMethod('checkForUpdate', {"staleness_days": stalenessDays});

    return UpdateInfo(result["isUpdateSuccess"], result["updateType"],
        result["isUpdateAvailable"]);
  }
}

class UpdateInfo {
  bool isUpdateSuccess;
  UpdateType updateType; // flexible 0, immediate 1
  bool isUpdateAvailable;

  UpdateInfo(this.isUpdateSuccess, int type, this.isUpdateAvailable)
      : updateType = type == 0 ? UpdateType.FLEXIBLE : UpdateType.IMMEDIATE;
}

enum UpdateType { FLEXIBLE, IMMEDIATE }
